Subject: Re: Proposed interface for per-packet mesh-ttl

From: Stephen Hemminger <[email-masked]>
Date: Thu, 16 Aug 2007 17:19:13 -0400

On Thu, 16 Aug 2007 12:21:14 -0700
"Luis Carlos Cobo" <[email-masked]> wrote:

> On 7/30/07, Stephen Hemminger <[email-masked]> wrote:
> > it would need an IP ttl to mesh mapping. The fundamental thing is to try
> > and avoid topology specific options bleeding all the way up the socket layer,
> > especially since the network layer is involved and may need to multipath.
> 
> I think the cleanest way would be to add a ll_ttl (ll for link layer)
> field to struct sock and a SO_LL_TTL socket option that sets both the
> field and a flag in sk->flags. This way it is useful for any driver
> that can do mesh or any other protocol that involves a ttl at link
> layer (not that I'm aware of any).
> 
> However I guess you are not supposed to add new socket options nor
> modify struct socket too often so I'd appreciate feedback on whether
> this would be considered a good approach.
> 
> -- 
> Luis Carlos Cobo Rus       GnuPG ID: 44019B60
> cozybit Inc.

The problem with socket options is how does the application know
the correct policy? Pushing configuration to application is just deferring
the problem, not solving it.  You want some policy to be done by the
infrastructure; that means kernel, libraries, daemons, etc. Doing it in
the application is often inflexible and unusable.